#include <sys/types.h>
#include <unistd.h>
#include <termios.h>
#include <fcntl.h>
#include <stdio.h>
#include <pwd.h>        /*   /etc/passwd */
#include <ctype.h>
#include <string.h>

#include "history.h"
#include "cmdline.h"

#define left '~'
#define right '~'

static int slen; /*   */
static int i,x; //   ,    .
static int sizep; //  
static struct termios oldflags; //    
static struct termios term; // 
static int cterm; // 
static int sizecmd; //  
static char qw; //  '#'  '$'

//   n 
void pn(char* c,int n){ int i; for(i=0; i<n; i++) printf("%s",c);} 
//  ,    a  b
void put(char* a,char* b){ char* q; for(q=a; q<b && *q; q++) putchar(*q);}

int prompt(void) /*   */
{ char* sdir, gdir[512];   //  . 
  int uid = getuid(), try;
  struct passwd *p = getpwuid(uid);
  char* s; //  
  
  time(&try); //  
  s=(char*)ctime(&try); //    
  *(s+16)='\0';
  getcwd(gdir,512); // . 
  sdir=(char*)strrchr(gdir,'/');
  if(sdir!=gdir) sdir++;
  sdir=strcmp(p->pw_dir,gdir) ? sdir:"~";
  qw = strcmp("root",p->pw_name)?'$':'#';
  printf("[%s %s %s]%c ",p->pw_name,s+11,sdir,qw);
  return 6+5+strlen(p->pw_name)+strlen(sdir);
}

void closeTTY() /*    */
{
    term=oldflags;	
    tcsetattr(cterm,TCSANOW,&term); 
}

void print()
{
 if(i<0) i=0;
 if(i>sizecmd) i=sizecmd;
 if(i<x) x=i;
 if(x+slen<i) x=i-slen;
 printf("\r");
 pn("\e[C",sizep-2);
 printf("%c\e[C\e[K",x ? left:qw);
 put(buf+x,buf+x+slen);
 printf("\e[C%c",x+slen < sizecmd ? right:' ');
 printf("\r"); pn("\e[C",sizep+i-x);//  
}
void add(char c)/*     i buf */
{
 if( isprint(c) )
 {
  if(0<=i && i<BUFLEN) memmove(buf+i+1,buf+i,strlen(buf+i)+1), buf[i]=c;
  sizecmd++; 
  i++; print();
 } 
}
void del()/*   buf  #i */
{
 if(0<=i && i<sizecmd)
 {
  memmove(buf+i,buf+i+1,strlen(buf+i+1)+1);
  sizecmd--;
  if(sizecmd-x < slen && x) x--, i--;  
  print();
 }
}

char* getcmd() /*    */
{
 int c, j=0;
 char* temp;
    cterm = open("/dev/tty",O_RDWR);

    tcflush(cterm,TCIOFLUSH); //  
    tcgetattr(cterm,&term);  //  
    oldflags = term;	  //       	
    //    ,
    //   SIGTTOU ( TOSTOP)
    //  SIGINT, SIGQUIT, SIGTSTP ( ISIG)
    term.c_lflag=term.c_lflag & (~ICANON)&(~ECHO)|TOSTOP|ISIG;	
    tcsetattr(cterm,TCSANOW,&term); //  
 i = x = 0;
 buf[0]='\0';
 sizep = prompt();
 slen = 79 - sizep;
 sizecmd = 0;
   for(;;)
   {
    char *s;
    c=getchar();
    
    switch(c) 
    {
     case 27:    
      c=getchar();
      if(c=='[')
      switch(getchar())
      {
       case 'D': i--; print(); break;//  
       case 'C': i++; print(); break; //        
       case 'A': if(s=prevhis()){strcpy(buf,s); sizecmd = strlen(buf); x=i=0; print();}
                 break; //  
       case 'B': if(s=nexthis()){strcpy(buf,s); sizecmd = strlen(buf); x=i=0; print();}
                 break; //  
       case '3': if(getchar()=='~') del(); break; // Delete
       case '4': if(getchar()=='~') i=sizecmd ,print(); break; // End		 
       case '1': if(getchar()=='~') i=0, print(); break; // Home
      }
      break;
     case 4:/* Ctrl+D */printf("\n"); closeTTY(); exit(0);
     case 0x7f:if(i){ i--; del(); } break; /* BackSpace */
     case 10:/* Enter */ goto Exit;
     default: add(c); //         
    }// switch
   } // for
Exit:
    addhis(buf); //  
//    printf("\ni=%i, x=%i, size=%i\n",i,x,sizecmd);
    closeTTY();
    printf("\n");
    return buf;
}
